
#ifndef _VLIBDRV_H
#define _VLIBDRV_H

#include <linux/module.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/fcntl.h>
#include <linux/string.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/timer.h>
#include <linux/sched.h>
#include <linux/slab.h>
#include <linux/pci.h>
#include <linux/interrupt.h>
#include <linux/ioport.h>
#include <linux/delay.h>
#include <linux/spinlock.h>
//#include <linux/tqueue.h>
#include <linux/file.h>
#include <linux/version.h>
#include <asm/irq.h>
#include <asm/io.h>
#include <asm/bitops.h>
#include <asm/system.h>
#include <asm/atomic.h>


enum 
{
    BIT0  = 0x00000001,
    BIT1  = 0x00000002,
    BIT2  = 0x00000004,
    BIT3  = 0x00000008,
    BIT4  = 0x00000010,
    BIT5  = 0x00000020,
    BIT6  = 0x00000040,
    BIT7  = 0x00000080,
    BIT8  = 0x00000100,
    BIT9  = 0x00000200,
    BIT10 = 0x00000400,
    BIT11 = 0x00000800,
    BIT12 = 0x00001000,
    BIT13 = 0x00002000,
    BIT14 = 0x00004000,
    BIT15 = 0x00008000,
    BIT16 = 0x00010000,
    BIT17 = 0x00020000,
    BIT18 = 0x00040000,
    BIT19 = 0x00080000,
    BIT20 = 0x00100000,
    BIT21 = 0x00200000,
    BIT22 = 0x00400000,
    BIT23 = 0x00800000,
    BIT24 = 0x01000000,
    BIT25 = 0x02000000,
    BIT26 = 0x04000000,
    BIT27 = 0x08000000,
    BIT28 = 0x10000000,
    BIT29 = 0x20000000,
    BIT30 = 0x40000000,
    BIT31 = (int)0x80000000
};


/*Probe PCI module funtion declaration*/
int plx_probe(struct pci_dev*, const struct pci_device_id*);
/*Close PCI module function declaration*/
void plx_close(struct pci_dev*);
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
void vlib_interrupt(int irq, void *dev_id, struct pt_regs *regs); /*Interrupt handler Declaration*/
#else
irqreturn_t vlib_interrupt(int irq, void *dev_id, struct pt_regs *regs); /*Interrupt handler Declaration*/
#endif
static int __devinit init_plx(void); /*PLX init function declaration*/
void dsp_hold_reset(struct pci_dev *pdev);
void vlib_interrupt_disable(struct pci_dev *);
void vlib_interrupt_enable(struct pci_dev *);

u32 plx_readmem(unsigned short card, unsigned int addr);
void plx_writemem(unsigned short card, u32 val,unsigned int addr);
/* Returns the device index into info array */
short plx_getdeviceindex(struct pci_dev*);
//int KERNEL_WRITE(short card,unsigned int addr, unsigned int data);
void KERNEL_WRITE(short card_type, unsigned long addr_space, unsigned long offset, unsigned long data);
unsigned int  KERNEL_READ(short card_type, unsigned long addr_space, unsigned long offset);
//unsigned int read_data(short card,unsigned int addr);
u16 plx_countcards(void);

#endif

/* SA_* flags such as SA_SHIRQ -> IRQF_SHARED marked for removal in Sep 2007
   See Documentation/feature-removal-schedule.txt.gz for more information */

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,22)
#define VLIB_IRQ_SHARED IRQF_SHARED
#else
#define VLIB_IRQ_SHARED SA_SHIRQ
#endif
